﻿# -*- coding: utf-8 -*-

import sys
import random
from PyQt5.QtCore import QEvent, QRectF, QTimer, Qt
from PyQt5.QtWidgets import QApplication
from PyQt5.QtGui import QBrush, QColor, QPainter
from PyQt5.uic import loadUi
from types import MethodType

colorL = 96
colorR = colorL # To do: würfeln!
anzeige = False

def handleEvents(self, event):
    if event.type() == QEvent.Paint:
        painter = QPainter()
        painter.begin(self)
        painter.fillRect(QRectF(0.0, 0.0, w.widget.width(), w.widget.height()),
                         QBrush(Qt.black))
        if anzeige:
            painter.fillRect(QRectF(0.1 * w.widget.width(), 0.1 * w.widget.height(), 0.35 * w.widget.width(), 0.8 * w.widget.height()),
                             QBrush(QColor.fromRgb(colorL, colorL, colorL)))
            painter.fillRect(QRectF(0.55 * w.widget.width(), 0.1 * w.widget.height(), 0.35 * w.widget.width(), 0.8 * w.widget.height()),
                             QBrush(QColor.fromRgb(colorR, colorR, colorR)))        
        painter.end()
    return True

def clickLinks():
    click(0)

def clickRechts():
    click(1)

def click(welcherButton):
    global colorR, anzeige
    if anzeige:
        f.write(str(colorL) + "," + str(colorR) + "," + str(welcherButton) + "\n")
        anzeige = False
        timer.start()
        w.widget.update()
    
def zeige():
    global colorR, anzeige
    anzeige = True;
    colorR = colorL + random.randint(-15, 15)
    w.widget.update()

timer = QTimer()
timer.setInterval(500) # Pause für schwarzes Bild zwischen den Tests
timer.setSingleShot(True)
timer.timeout.connect(zeige)    
f = open("jnd.csv", "w")
app = QApplication(sys.argv)
w = loadUi("jnd.ui")
w.widget.event = MethodType(handleEvents, w.widget)
w.pushButton_links.clicked.connect(clickLinks)
w.pushButton_rechts.clicked.connect(clickRechts)
w.show()
timer.start()
sys.exit(app.exec_())